
use XML::Generator;
use Time::Local 'timelocal_nocheck';

my $xml = XML::Generator->new(escape => 'always',
                                 pretty => 2,
                                 conformance => 'strict');
my $author_page_URL;
my $xml_file;
my @files;
my $count=-1;
my $now=gmtime;
my ($dtmax,$dwmax);
use Tie::Hash::Rank;
  tie my %total_downloads, 'Tie::Hash::Rank';
  tie my %week_downloads, 'Tie::Hash::Rank';

use LWP::Simple;	#module for transferring HTML
my @gen_stats;	#general statistics
print "This program makes a report of all file statistics of your files at ticalc.org\n";
chomp($author_page_URL=shift);	#loads argument
if (not defined $author_page_URL) {
print "Enter your author page URL here (winNT users:Paste->right mouse click) :";
chomp($author_page_URL=<STDIN>)};	#ask for user input if no argument is given;

print "\n\nTransferring author page...\n";
getstore($author_page_URL,"author page.html");	#store author page
open DATA , "author page.html";				#open author page
my $trigger;
my $trigger2;
my $ref;
my $status;
$xml_file = '<?xml version="1.0"  encoding="iso-8859-1"?>'."\n";
$xml_file .= '<?xml:stylesheet type="text/xsl" href="sss.xsl"?>';

while (<DATA>) {chomp;				#loop through the author page
	if (/busiest authors/) {		#watch for the general stat header
		for(my $cnt=0;$cnt<6;$cnt++) {
		s/(\d+) /x/;             	#detects numbers and replaces them with x
		push @gen_stats,$1;}		#put those numbers in an array
		$xml_file .= $xml->general($xml->num_files({rank => $gen_stats[0]},$gen_stats[1]),
			$xml->total_download({rank => $gen_stats[2]},$gen_stats[3]),
			$xml->week_download({rank => $gen_stats[4]},$gen_stats[5]))."\n";
					#generates XML
		undef @gen_stats;
	}
	if (not defined $trigger) {if (/TITLE>(.*?) -/) {$xml_file .= "<statistics owner=\"$1\" URL=\"$author_page_URL\">\n";$xml_file .= $xml->noXSLT("----&gt;Your browser doesn't support XSLT, try Internet Explorer 6&lt;----")."\n";$trigger=1};};
	if ($trigger2==2) {/>([^<>]+)</; my $name=$1;		#file name is found between > and <
		getstore("http://www.ticalc.org/".$ref,"file page.html"); #save file page
		open FILE , "file page.html";					#open file page
		$count++;
		my $attname;
		$xml_file .= "<FILE name=\"$name\" URL=\"$ref\" cnt=\"$count\" status=\"$status\">\n";
		push @files,$name;
		my $trigger3;
		print "processing...  $name\n";
		my $store_ =$_;
		while (<FILE>) {chomp;
			if (/Ranked as/) {
				for(my $cnt=0;$cnt<4;$cnt++) {
				s/(\d+) /x/;		#detects numbers and replaces them with x
				push @gen_stats,$1;}	#put those numbers in an array
				$total_downloads{$count}=$gen_stats[1];
				$week_downloads{$count}=$gen_stats[3];
				$xml_file .= "  ".$xml->total_download({rank => $gen_stats[0]},$gen_stats[1])."\n";
				$xml_file .= "  ".$xml->week_download({rank => $gen_stats[2]},$gen_stats[3])."\n";
				if ($gen_stats[1]>$dtmax) {$dtmax=$gen_stats[1]};
				if ($gen_stats[3]>$dwmax) {$dwmax=$gen_stats[3]};
				undef @gen_stats;
				}
			if ($trigger3==2 and (/^[^<]/) and not(/^Author/ or /^Category/)) { #checks if line starts not with < or Author or Category
				my $des=$_;
				my $store=$_;
				while (<FILE>) {chomp;if ((/^</) and $_ ne "") {last};$des.=$_;}	#read all lines not starting with <
				$_=$store;
				$des =~ s/>/&gt;/g;
				$des =~ s/</&lt;/g;	#replace illegal XML chars |||||||
				if ($attname eq "File_Date_and_Time") {$xml_file .= "  ".$xml->$attname({epsec => string2epsec($des)},$des)."\n";
				} elsif ($attname eq "File_Size"){$xml_file .= "  ".$xml->$attname({bytes => unformat($des)},$des)."\n";
				} else {$xml_file .= "  ".$xml->$attname($des)."\n";}
				$trigger3=9;}
			if ((/^Title/) and $trigger3==undef) {$trigger3=1;}
			if (($trigger3==1) and (/^[^<]/) and not(/^Author/ or /^Category/)) {s/ /_/g;$attname=$_;$trigger3=2;}	
			if ($trigger3==9) {$trigger3=1;}
			if (/\d\d:\d\d:\d\d/) {last;}
			if ($trigger3==1 and /^<B><A HREF="(.*)">(.*)<\/A/) {$xml_file .= "  ".$xml->Category({URL => $1},$2)."\n";}
		}
		$_=$store_;
		close FILE;	
		$xml_file .= "</FILE>\n";
	$trigger2++;}
	if ($trigger2==1) {/^<A HREF=\"([^\"]*)\"><IMG BORDER=\"0\" SRC=\"(.*?)\"/;$ref=$1;$status=$2;$trigger2++;}
	if ($trigger2==undef and (/TD class=t1 VALIGN="TOP"/)) {$trigger2=1;}
	if (($trigger2==3) and (/<TR BGCOLOR/)) {undef $trigger2;}
}
print "calculating private ranking...\n";
my ($wmax,$tmax);
for ($a=0;$a<@files;$a++) {$xml_file .= $xml->PR({n => $a,w => $week_downloads{$a}, t=> $total_downloads{$a}})."\n";
					if ($week_downloads{$a}>$wmax) {$wmax=$week_downloads{$a}};if ($total_downloads{$a}>$tmax) {$tmax=$total_downloads{$a}};}
		#generate ranking data
$xml_file .= $xml->PRMAX({w=> $wmax,t => $tmax})."\n";
$xml_file .= $xml->DMAX({w=>$dwmax,t=>$dtmax})."\n";
print "generating XML...\n";
$xml_file .= $xml->CREATETIME({zone => 'GMT'},$now)."\n";
$xml_file .= '</statistics>';				
open XML ,">report.xml";
print XML $xml_file;
close XML;
close DATA;
print "deleting temporary files...\n";
unlink ("file page.html","author page.html");
print "start XML2HTML.pl to see the report\n";

open BAT,">shortcut.bat";
print BAT "TIreport.pl $author_page_URL";
close BAT;


sub string2epsec{
my $mon;
my @month= qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
my $time=shift;
$time =~ /\w+ (\w+) +(\d+) (\d+):(\d+):(\d+) (\d+)/;
for (my $x=0;$x<12;$x++) {
if ($month[$x] eq $1) {$mon=$x;}}
timelocal_nocheck($5,$4,$3,$2,$mon,$6);
}
sub unformat {
my $str=shift;
$str=~s/,//g;
my ($size,$units)=split(/ /,$str);
if (lc($units)=~ /k/) {$size *= 1024;$units="bytes";}
if (lc($units)=~/m/) {$size *= 1024*1024;$units="bytes";}
return $size;
}


