<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:param name="column">name</xsl:param>
<xsl:param name="order">ascending</xsl:param>
<xsl:template match="/">
<HTML>
<HEAD />
<BODY>
<FONT FACE="Verdana,Arial,Helvetica" SIZE="4">
<B>
File statistics at <A href="http://www.ticalc.org">ticalc.org</A> of author: <A HREF="{statistics/@URL}"><xsl:value-of select="statistics/@owner"/></A><BR/>
</B>
Total files owned: by ticalc:<B><xsl:value-of select="//general/num_files"/></B>(<A HREF="http://www.ticalc.org/archives/files/authors.html#1">rank</A> =  <xsl:value-of select="//general/num_files/@rank"/>)<BR/>
Actually: <B><xsl:value-of select="count(//FILE)"/></B>  (some directories don't include ranking)<BR/>
</FONT>

<FONT SIZE="1">the table is sorted <xsl:value-of select="$order" /> by <xsl:value-of select="$column" /></FONT>

<TABLE BORDER="2">
	<TR >
		<TH>File name</TH>
		<TH>Category</TH>
		<TH>Title</TH>
		<TH colspan="2">Total download</TH>
		<TH><A HREF="http://www.ticalc.org/archives/files/stats.html#2">rank</A></TH>
		<TH colspan="2">Week download</TH>
		<TH><A HREF="http://www.ticalc.org/archives/files/stats.html#1">rank</A></TH>
		</TR>
		<xsl:choose>
			<xsl:when test="$column='name'"><xsl:apply-templates select="//FILE"><xsl:sort select="./@name" data-type="text" order="{$order}"/></xsl:apply-templates></xsl:when>
			<xsl:when test="$column='total_download'"><xsl:apply-templates select="//FILE"><xsl:sort select="./total_download" data-type="number" order="{$order}"/><xsl:sort select="./week_download" data-type="number" order="{$order}"/></xsl:apply-templates></xsl:when>
			<xsl:when test="$column='Title'"><xsl:apply-templates select="//FILE"><xsl:sort select="./Title" data-type="text" order="{$order}"/></xsl:apply-templates></xsl:when>
			<xsl:when test="$column='Category'"><xsl:apply-templates select="//FILE"><xsl:sort select="./Category" data-type="text" order="{$order}"/></xsl:apply-templates></xsl:when>
			<xsl:when test="$column='week_download'"><xsl:apply-templates select="//FILE"><xsl:sort select="./week_download" data-type="number" order="{$order}"/><xsl:sort select="./total_download" data-type="number" order="{$order}"/></xsl:apply-templates></xsl:when>
			<xsl:when test="$column='date'"><xsl:apply-templates select="//FILE"><xsl:sort select="./File_Date_and_Time/@epsec" data-type="number" order="{$order}"/></xsl:apply-templates></xsl:when>
			<xsl:when test="$column='size'"><xsl:apply-templates select="//FILE"><xsl:sort select="./File_Size/@bytes" data-type="number" order="{$order}"/></xsl:apply-templates></xsl:when>
			<xsl:when test="$column='description length'"><xsl:apply-templates select="//FILE"><xsl:sort select="string-length(./Description)" data-type="number" order="{$order}"/></xsl:apply-templates></xsl:when>
			<xsl:when test="$column='title length'"><xsl:apply-templates select="//FILE"><xsl:sort select="string-length(./Title)" data-type="number" order="{$order}"/></xsl:apply-templates></xsl:when>
			<xsl:when test="$column='file status'"><xsl:apply-templates select="//FILE"><xsl:sort select="./@status" data-type="text" order="{$order}"/></xsl:apply-templates></xsl:when>
		</xsl:choose>
		<TR/>
		<TR>
		<TD><B>Averages</B></TD>
		<TD/>
		<TD/>
		<TD><hr size="4" align="left" width="{100 div //DMAX/@t * (//general/total_download div //general/num_files)}%" color="blue" title="{format-number(100 div //DMAX/@t * (//general/total_download div //general/num_files),'###.##')}% downloads, relative to the file with most downloads"/></TD>
		<TD ALIGN="right"><xsl:value-of select="format-number(//general/total_download div //general/num_files,'#,###.#')"/></TD>
		<TD ALIGN="right"><xsl:value-of select="format-number(sum(//FILE/total_download/@rank) div //general/num_files,'#,###,###')"/></TD>
		<TD><hr size="4" align="left" width="{100 div //DMAX/@w * (//general/week_download div //general/num_files)}%" color="blue" title="{format-number(100 div //DMAX/@w * (//general/week_download div //general/num_files),'###.##')}% downloads, relative to the file with most downloads"/></TD>
		<TD ALIGN="right"><xsl:value-of select="format-number(//general/week_download div //general/num_files,'#.##')"/></TD>
		<TD ALIGN="right"><xsl:value-of select="format-number(sum(//FILE/week_download/@rank) div //general/num_files,'#,###,###')"/></TD>		
		</TR>
		<TR/>
		<TR>
		<TD><B>Totals</B></TD>
		<TD/>
		<TD/>
		<TD title="no meaning, just enlarges the width">xxxxxxx</TD>
		<TD ALIGN="right"><xsl:value-of select="format-number(//general/total_download,'#,###,###')"/></TD>
		<TD ALIGN="right"><A href="http://www.ticalc.org/archives/files/authors/index.html#3"><xsl:value-of select="format-number(//general/total_download/@rank,'#,###,###')"/></A></TD>
		<TD title="no meaning, just enlarges the width">xxxxxxx</TD>
		<TD ALIGN="right"><xsl:value-of select="format-number(//general/week_download,'#,###')"/></TD>
		<TD ALIGN="right"><A href="http://www.ticalc.org/archives/files/authors/index.html#2"><xsl:value-of select="format-number(//general/week_download/@rank,'#,###,###')"/></A></TD>
		</TR>
</TABLE>
<BR/>
<A href="mailto:roac@pandora.be">send</A> your feedback!<BR/>
<A href="mailto:roac@pandora.be?subject=bug found!">report</A> a bug<BR/>
<A href="mailto:roac@pandora.be?subject=help!">I need help !!</A><BR/>
<BR />
<A href="manual.doc">view manual</A><BR/><BR/>
created by Perl on <xsl:value-of select="//CREATETIME"/> (<xsl:value-of select="//CREATETIME/@zone"/>)

</BODY>
</HTML>
</xsl:template>

<xsl:template match="//FILE">

		<TR>
		<TD title="Contribution date: {./File_Date_and_Time} &#13;&#10;File size: {./File_Size}"><A HREF="http://www.ticalc.org{./@URL}"><IMG BORDER="0" SRC="http://www.ticalc.org{./@status}" /> <xsl:value-of select="./@name"/></A></TD>
		<TD><A href="http://www.ticalc.org{./Category/@URL}"><xsl:value-of select="./Category"/></A></TD>
		<TD title="{./Description}"><xsl:value-of select="./Title"/></TD>
		<xsl:variable name="count" select="./@cnt"/>
		<xsl:variable name="total" select="round(255 div (//PRMAX/@t -1) * (//PR[@n=$count]/@t -1))"/>
		<xsl:variable name="week" select="round(255 div (//PRMAX/@w -1) * (//PR[@n=$count]/@w -1))"/>
		<xsl:choose>
			<xsl:when test="($total+1) &gt; 0">
			<TD title="this file owns {format-number(100 div //general/total_download * ./total_download,'###.##')}% of your downloads"><hr size="4" align="left" width="{100 div //DMAX/@t * ./total_download}%" color="blue" title="{format-number(100 div //DMAX/@t * ./total_download,'###.##')}% downloads, relative to the file with most downloads"/></TD>
			<xsl:variable name="red"><xsl:call-template name="byte2hex"><xsl:with-param name="num" select="$total" /></xsl:call-template></xsl:variable>
			<xsl:variable name="green"><xsl:call-template name="byte2hex"><xsl:with-param name="num" select="255-$total" /></xsl:call-template></xsl:variable>
			<TD nowrap="true" ALIGN="right" BGCOLOR="#{$red}{$green}00" title="private total rank:{//PR[@n=$count]/@t}/{//PRMAX/@t}">
			<B><xsl:value-of select="format-number(./total_download,'#,###')"/></B>
			</TD>
			<TD ALIGN="right"><xsl:value-of select="format-number(./total_download/@rank,'#,###,###')"/></TD>
			</xsl:when>
			<xsl:otherwise>
			<TD/><TD/><TD/>
			</xsl:otherwise>
		</xsl:choose>
		
		<xsl:choose>
			<xsl:when test="($week+1) &gt; 0">
			<TD title="this file owns {format-number(100 div //general/week_download * ./week_download,'###.##')}% of your downloads"><xsl:if test="./week_download &gt; 0"><hr size="4" align="left" width="{100 div //DMAX/@w * ./week_download}%" color="blue" title="{format-number(100 div //DMAX/@w * ./week_download,'###.##')}% downloads, relative to the file with most downloads"/></xsl:if></TD>
			<xsl:variable name="red"><xsl:call-template name="byte2hex"><xsl:with-param name="num" select="$week" /></xsl:call-template></xsl:variable>
			<xsl:variable name="green"><xsl:call-template name="byte2hex"><xsl:with-param name="num" select="255-$week" /></xsl:call-template></xsl:variable>
			
			<TD ALIGN="right" BGCOLOR="#{$red}{$green}00"  title="private week rank:{//PR[@n=$count]/@w}/{//PRMAX/@w}"><B><xsl:value-of select="./week_download"/></B></TD>
			<TD ALIGN="right"><xsl:value-of select="format-number(./week_download/@rank,'#,###,###')"/></TD>
			</xsl:when>
			<xsl:otherwise>
			<TD/><TD/><TD/>
			</xsl:otherwise>
		</xsl:choose>
		</TR>
		
</xsl:template>
<xsl:template name="byte2hex">
	<xsl:param name="num" />
	<xsl:variable name="lsd" select="$num mod 16" />
	<xsl:variable name="msd" select="($num - $lsd) div 16" />
	<xsl:value-of select="substring('0123456789ABCDEF',$msd+1,1)" />
	<xsl:value-of select="substring('0123456789ABCDEF',$lsd+1,1)" />
</xsl:template>
</xsl:stylesheet>